#include "classeditor.h"
#include "ui_classeditor.h"


ClassEditor::ClassEditor(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ClassEditor)
{
    ui->setupUi(this);

    
    
    //    settdialog = new SettingsDialog(this);
  /////////////////////////////////////////////////////  settdialog.show();
    sql.setDatabaseName(tr("an_db"));

/*
    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));

    table = new SqlTable (tr("NewTable"), this);
    table->setName(tr("NewTable"));
    table->fields().at(0)->setNotNull(true);
    if (!(table->setPrimaryKey(tr("ID")))) {
         ui->label_3->setText(table->lastError());
    }
    else  ui->label_3->setText(table->primaryKey());
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(""), this);
    field->setNotNull(true);
    field->setDefaultValue(tr(""));
    table->append(field);

    field = new TableField(tr(" ()"), this);
    field->setNotNull(true);
    field->setType(tr("INTEGER"));
    field->setDefaultValue(tr("1"));
    table->append(field);

    field = new TableField(tr(" "), this);
    field->setNotNull(false);
    field->setType(tr("DATE"));
    field->setDefaultValue(tr("NULL"));
    table->append(field);

    ui->label_2->setText(table->name());
    ui->label->setText(table->fields().at(0)->sqlString());
    ui->label_4->setText(table->sqlString());
   ////// ui->lineEdit->insert(table->sqlString());

*/
    /**********************************************

    QTextDocument *document;
    // = ui->textEdit->document();
    QTextCursor *cursor;

    document = ui->textEdit->document();
    cursor = new QTextCursor(document);
    cursor->movePosition(QTextCursor::Start);
QTextCharFormat format(cursor->charFormat());
//format.setFontFamily("Courier");
format.setFontFamily("Arial");
//format.setFontItalic(false);

format.setFontWeight(QFont::Normal);
QTextCharFormat boldFormat = format;
boldFormat.setFontWeight(QFont::Bold);

QTextCharFormat italicFormat = format;
//format.setFontFamily("Courier");
//     format.setFontFamily("Arial");
italicFormat.setFontItalic(true);

cursor->insertText(table->sqlString(), format);

****************************************************/

QString errorString;

sql.setDatabaseName(tr("an_db"));
sql.setHostName(tr("localhost"));
sql.setUserName(tr("an"));
sql.setPassword(tr("393939"));

bool ok;
ok = sql.connect();
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .





}

/*
ok = sql.createTable(table);
if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .
         }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Connect"),   // .
                                                    QObject::tr("     ."));         //  .
     }



*/

ok = sql.createListOfClassesTable();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Create"),   // .
                                                    QObject::tr("   ."));         //  .
    }




ok = sql.createDescriptionOfClassesTable();

if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lasError());         //  .

                     }
else {

    QMessageBox::information( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Create"),   // .
                                                    QObject::tr("   ."));         //  .
    }







/////////////////model = new QSqlTableModel(this);
mymodel = new MyModel(this);
//modelForDescription = new QSqlTableModel(this);
modelForDescription = new ModelForDescriptionTable(this);


/////////////////model->setTable(tr("ListOfClasses"));
mymodel->setTable(tr("ListOfClasses"));
modelForDescription->setTable(tr("DescriptionOfClasses"));
modelForDescription->setEditStrategy(QSqlTableModel::OnFieldChange);

/////model->setEditStrategy(QSqlTableModel::OnManualSubmit);

/*
model->setEditStrategy(QSqlTableModel::OnFieldChange);
mymodel->setEditStrategy(QSqlTableModel::OnFieldChange);
*/


//////////////////model->setSort(0, Qt::AscendingOrder);
mymodel->setSort(0, Qt::AscendingOrder);
modelForDescription->setSort(0, Qt::AscendingOrder);


//       model->setFilter(tr("__ = '7' and _ = 'i09090909'"));
////////////////////model->select();
mymodel->select();
modelForDescription->setFilter(tr("ClassIdentifer = 1"));
modelForDescription->select();


/////////////////////////model->setHeaderData(1, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(1, Qt::Horizontal, tr(" "));



////////////////////////model->setHeaderData(2, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(2, Qt::Horizontal, tr(" "));
mymodel->setHeaderData(4, Qt::Horizontal, tr(""));


//ui->tableView->setModel(model);
ui->tableView->setModel(mymodel);
//tableForDescription = new QTableView();
ui->tableView_2->setModel(modelForDescription);
ui->tableView_2->setAlternatingRowColors(true);
ui->tableView_2->resizeColumnsToContents();
//tableForDescription->show();


ui->tableView->setAlternatingRowColors(true);
ui->tableView->resizeColumnsToContents();

ui->tableView->hideColumn(0);
ui->tableView->hideColumn(3);
ui->tableView->hideColumn(2);

/*
ui->tableView_2->hideColumn(0);
ui->tableView_2->hideColumn(5);
ui->tableView_2->hideColumn(2);
*/
ui->tableView_2->setItemDelegateForColumn(3, &classTableDelegate);

currIndexOfClassesTable = modelForDescription->index(0, 1);
QModelIndex index_temp;

currClassID = mymodel->data(mymodel->index(0,0)).toString();
QItemSelectionModel *selectionModel = ui->tableView->selectionModel();

QModelIndex topLeft;
QModelIndex bottomRight;

     topLeft = mymodel->index(0, 0, QModelIndex());
     bottomRight = mymodel->index(0, 1, QModelIndex());

QItemSelection selection(topLeft, bottomRight);
selectionModel->select(selection, QItemSelectionModel::Select);



//connect(ui->tableView, SIGNAL(clicked(const QModelIndex)), this, SLOT(on_tableView_clicked(const QModelIndex)));
connect(mymodel, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_myModel_dataChanged(QModelIndex,QModelIndex)));
connect(modelForDescription, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_modelForDescription_dataChanged(QModelIndex,QModelIndex)));
connect(ui->newClassAction, SIGNAL(triggered(bool)), this, SLOT(on_pushButton_clicked(bool)));
connect(ui->action_ID, SIGNAL(triggered(bool)), this, SLOT(on_action_ID_triggered(bool)));
connect(ui->action_showAlias, SIGNAL(triggered(bool)), this, SLOT(on_action_showAlias_triggered(bool)));
connect(ui->action_showInstance, SIGNAL(triggered(bool)), this, SLOT(on_action_showInstance_triggered(bool)));
}











ClassEditor::~ClassEditor()
{
    delete ui;
 //    delete field;
   // delete settdialog;
}

void ClassEditor::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}



void  ClassEditor::addNewClass(){

    int row = model->rowCount();

    model->insertRows(row, 1);
    model->setData(model->index(row, 1), tr("New class")); //     " "


    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    model->submitAll();

    row = model->rowCount();
    QString tmp_str;
    int i_tmp;
    i_tmp = model->data(model->index(row-1, 0)).toInt();
    tmp_str = model->data(model->index(row-1, 0)).toString(); //   -  

    tmp_str.append(tr("_Inctance"));
    model->setData(model->index(row-1, 3), tmp_str );  //     

    model->submitAll();
    mymodel->select();


}


void  ClassEditor::addNewClass_new(){

    int row = mymodel->rowCount();

    mymodel->insertRows(row, 1);
    mymodel->setData(mymodel->index(row, 1), QVariant(tr("New classs")), Qt::EditRole); //     " "

    mymodel->submitAll();

    row = mymodel->rowCount();
    QString tmp_str1;
    int i_tmp1;
    i_tmp1 = mymodel->data(mymodel->index(row-1, 0)).toInt();
    tmp_str1 = mymodel->data(mymodel->index(row-1, 0)).toString(); //   -  

    tmp_str1.append(tr("_Inctance"));
    mymodel->setData(mymodel->index(row-1, 3), QVariant(tmp_str1), Qt::EditRole);  //     

    // model->setData(model->index(row, 1), tr("   "));
    // model->setData(model->index(row, 2) , tr("  ,    1"));


    //mymodel->submitAll();

    //row = mymodel->rowCount();


  //mymodel->select();


}


void ClassEditor::addNewField(){
    // QSqlRecord rec = mymodel->record(1);
     //bool ok;
     //ok = rec.isEmpty();
     //QString currientClassID;
     //currientClassID = rec.value(1).toString();
    int row = modelForDescription->rowCount();
    modelForDescription->insertRows(row, 1);
    modelForDescription->setData(modelForDescription->index(row, 5), QVariant(currClassID), Qt::EditRole);
    modelForDescription->setData(modelForDescription->index(row, 4), QVariant(tr("NULL")), Qt::EditRole);

    modelForDescription->submitAll();
}











void ClassEditor::on_pushButton_clicked(){
//int i;
//i++;
/////ClassEditor::addNewClass();
ClassEditor::addNewClass_new();
 mymodel->select();
//ui->tableView->setModel(mymodel);

}

void ClassEditor::on_tableView_clicked(const QModelIndex & index ){
    int i, row, column;
    i++;
    row = index.row();
    column = index.column();
    currIndexOfClassesTable = index;
    QModelIndex index_tmp;
    QString tmp_str, filter_str;
   index_tmp = ui->tableView->model()->index(row, 0);
   tmp_str = ui->tableView->model()->data(index_tmp).toString();
   currClassID = tmp_str;
  // ui->label->setText(QVariant(currIndexOfClassesTable.row()).toString());
   filter_str = tr("ClassIdentifer = ");
   filter_str.append(tmp_str);
   modelForDescription->setFilter(filter_str);
   ui->tableView_2->resizeColumnsToContents();
   i++;
}



void ClassEditor::on_pushButton_2_clicked(){
    int i;
    i++;

}

void ClassEditor::on_pushButton_3_clicked(){         //    " "
    int i;
    i++;
    ClassEditor::addNewField();
    ClassEditor::modelForDescription->select();
    ui->tableView_2->resizeColumnsToContents();
}
void ClassEditor::on_pushButton_4_clicked(){         //    " "
    int i;
    i++;
    QModelIndex model_index;
    QItemSelectionModel *selectionModel = ui->tableView_2->selectionModel();
    QModelIndexList indexes = selectionModel->selectedIndexes();
    //model_index = mymodel->selec;
    //modelList = ui->tableView->SelectItems;
    i = indexes.size();
    QList<int> selectedRows;
    selectedRows.clear();
    foreach (model_index, indexes){ //    
        if (!selectedRows.contains(model_index.row()))  selectedRows.append(model_index.row());

    }
    i = selectedRows.size();

    if (i > 0) model_index = indexes.at(0);
    i++;
}


void ClassEditor::on_pushButton_5_clicked(){         //    "  "
int row;
row = ClassEditor::modelForDescription->rowCount();
ClassEditor::modelForDescription->removeRows(0, row);
ClassEditor::modelForDescription->submitAll();
}

void ClassEditor::on_myModel_dataChanged( const QModelIndex & topLeft, const QModelIndex & bottomRight ){
int i;
i++;
ui->tableView->resizeColumnsToContents();
}

void ClassEditor::on_modelForDescription_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ){
    ui->tableView_2->resizeColumnsToContents();
}

void ClassEditor::on_action_ID_triggered(bool is_checked){          //     " ID"
if (is_checked) ui->tableView->showColumn(0);
else ui->tableView->hideColumn(0);
ui->tableView->resizeColumnsToContents();
}

void ClassEditor::on_action_showAlias_triggered(bool is_checked){     //     " "
    if (is_checked) ui->tableView->showColumn(2);
    else ui->tableView->hideColumn(2);
    ui->tableView->resizeColumnsToContents();
}

void ClassEditor::on_action_showInstance_triggered(bool is_checked){
    if (is_checked) ui->tableView->showColumn(3);
    else ui->tableView->hideColumn(3);
    ui->tableView->resizeColumnsToContents();
}
