#ifndef DELEGATEFORCLASSESTABLE_H
#define DELEGATEFORCLASSESTABLE_H


#include <QItemDelegate>
#include <QModelIndex>
#include <QObject>
#include <QSize>
#include <QSpinBox>

class DelegateForClassesTable : public QItemDelegate
{
Q_OBJECT
public:
    explicit DelegateForClassesTable(QObject *parent = 0);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;

    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const;

    void updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option, const QModelIndex &index) const;

private:
    QStringList items;

signals:

public slots:

};





#endif // DELEGATEFORCLASSESTABLE_H
